<?php
/**
 *
 * Project: incoreSMS
 * User: unrlab
 *
 */
require_once('../../bootstrap.php');

Core_Auth::authorization($sModule = 'ofdferma');

// Код формы
$oAdmin_Form = Core_Entity::factory('Admin_Form')->getByGuid('ofdferma_list');
$sAdminFormAction = '/admin/ofdferma/index.php';

// Контроллер формы
$oAdmin_Form_Controller = Admin_Form_Controller::create($oAdmin_Form);
$oAdmin_Form_Controller
	->module(Core_Module::factory($sModule))
	->setUp()
	->path($sAdminFormAction)
	->title(Core::_('Ofdferma.title'))
	->pageTitle(Core::_('Ofdferma.title'));

// Меню формы
$oAdmin_Form_Entity_Menus = Admin_Form_Entity::factory('Menus');

// Элементы меню
$oAdmin_Form_Entity_Menus->add(
    Admin_Form_Entity::factory('Menu')
        ->name(Core::_('Ofdferma.settings'))
            ->icon('fa fa-user')
            ->img('/admin/images/user.png')
            ->href(
                $oAdmin_Form_Controller->getAdminActionLoadHref($oAdmin_Form_Controller->getPath(), 'settings', NULL, 0, 0)
            )
            ->onclick(
                $oAdmin_Form_Controller->getAdminActionLoadAjax($oAdmin_Form_Controller->getPath(), 'settings', NULL, 0, 0)
            )
);

// Добавляем все меню контроллеру
$oAdmin_Form_Controller->addEntity($oAdmin_Form_Entity_Menus);


// Действие настройка доступа
$oAdmin_Form_Action = $oAdmin_Form
    ->Admin_Form_Actions
    ->getByName('settings');

if ($oAdmin_Form_Action && $oAdmin_Form_Controller->getAction() == 'settings')
{
	$oOfdferma_Controller_Settings = Admin_Form_Action_Controller::factory(
            'Ofdferma_Controller_Settings', $oAdmin_Form_Action
	);

	// Элементы строки навигации
	$oAdmin_Form_Entity_Breadcrumbs = Admin_Form_Entity::factory('Breadcrumbs');

	// Элементы меню
	$oAdmin_Form_Entity_Breadcrumbs->add(
            Admin_Form_Entity::factory('Breadcrumb')
                ->name(Core::_('Ofdferma.host_menu'))
                ->href(
                    $oAdmin_Form_Controller->getAdminLoadHref($oAdmin_Form_Controller->getPath(), NULL, NULL, '')
                )
                ->onclick(
                    $oAdmin_Form_Controller->getAdminLoadAjax($oAdmin_Form_Controller->getPath(), NULL, NULL, '')
                )
	);

	$oOfdferma_Controller_Settings
            ->addEntity($oAdmin_Form_Entity_Breadcrumbs);

	// Добавляем типовой контроллер редактирования контроллеру формы
	$oAdmin_Form_Controller->addAction($oOfdferma_Controller_Settings);
}

if ($oAdmin_Form_Action && $oAdmin_Form_Controller->getAction() == 'updateStatus')
{
	$oOfdferma_Controller_UpdateStatus = Admin_Form_Action_Controller::factory(
            'Ofdferma_Controller_UpdateStatus', $oAdmin_Form_Action
	);

	// Добавляем контроллер редактирования контроллеру формы
	$oAdmin_Form_Controller->addAction($oOfdferma_Controller_UpdateStatus);
}

// Источник данных 1
$oAdmin_Form_Dataset = new Admin_Form_Dataset_Entity(
	Core_Entity::factory('Ofdferma')
);

$oModelOfdferma = Core_Entity::factory('Ofdferma');

$aDataTypes = $oModelOfdferma->_api->getDataType();
array_walk($aDataTypes, function(&$item, $key){
    $item = "$key=$item";
});


//Тип чека
$oAdmin_Form_Dataset->changeField('type', 'list', implode("\n", $aDataTypes));

//Ссылка на заказ
$oAdmin_Form_Dataset->changeField('order_id', 'type', '4');
$oAdmin_Form_Dataset->changeField('order_id', 'link', '/admin/shop/order/index.php?hostcms[action]=edit&hostcms[checked][0][{order_id}]=1&shop_id={shop_id}');
$oAdmin_Form_Dataset->changeField('order_id', 'onclick', "$.adminLoad({path: '/admin/shop/order/index.php', additionalParams: 'hostcms[checked][0][{order_id}]=1&shop_id={shop_id}', action: 'edit', windowId: '{windowId}'}); return false");

// Ограничение источника 1 по родительской группе
$oAdmin_Form_Dataset->addCondition(
    array(
        'where' => array('site_id', '=', CURRENT_SITE)
    )
);

// Добавляем источник данных контроллеру формы
$oAdmin_Form_Controller->addDataset(
    $oAdmin_Form_Dataset
);

// Показ формы
$oAdmin_Form_Controller->execute();
