<?php

defined('HOSTCMS') || exit('HostCMS: access denied.');

/**
 *
 * Project: ofdferma
 * User: unrlab
 *
 */
class Ofdferma_Controller_Settings extends Admin_Form_Action_Controller_Type_Edit
{


	/**
	 * Set object
	 * @param object $object object
	 * @return self
	 */
	public function setObject($object)
	{
            parent::setObject($object);

            $this->title(Core::_('Ofdferma.settings'));

            //СТандартная вкладка, удаляем ее
            $oAdditionalTab = $this->getTab('additional');
            $oAdditionalTab->delete($this->getField('site_id'));

            //Получаем модель
            $oModelOfdferma = Core_Entity::factory('Ofdferma');


            //Создаем вкладку настроек
            $oTabIncore = Admin_Form_Entity::factory('Tab')
                ->caption(Core::_('Ofdferma.settings'))
                ->name('main');


            /*Поля настроек*/

            // Логин
            $setting_user = Admin_Form_Entity::factory('Input')
                ->caption(Core::_('Ofdferma.setting_user'))
                ->name('OFDFERMA_USER')
                ->value(defined('OFDFERMA_USER') ? OFDFERMA_USER : '');

            // Пароль
            $setting_pass = Admin_Form_Entity::factory('Input')
                ->caption(Core::_('Ofdferma.setting_pass'))
                ->name('OFDFERMA_PASS')
                ->type('password')
                ->value(defined('OFDFERMA_PASS') ? OFDFERMA_PASS : '');

            // Инн
            $setting_inn = Admin_Form_Entity::factory('Input')
                ->caption(Core::_('Ofdferma.setting_inn'))
                ->name('OFDFERMA_INN')
                ->value(defined('OFDFERMA_INN') ? OFDFERMA_INN : '');

            //Система налогооблажения
            $setting_nalog = Admin_Form_Entity::factory('Select')
                ->options($oModelOfdferma->_api->getDataNalog())
                ->name('OFDFERMA_NALOG')
                //->divAttr(array('class' => 'form-group col-xs-12 col-sm-4'))
                ->value(defined('OFDFERMA_NALOG') ? OFDFERMA_NALOG : '')
                ->caption(Core::_('Ofdferma.setting_nalog'));

            // НДС по умолчанию
            $setting_vat = Admin_Form_Entity::factory('Select')
                ->options($oModelOfdferma->_api->getDataVat())
                ->name('OFDFERMA_VAT')
                ->value(defined('OFDFERMA_VAT') ? OFDFERMA_VAT : '')
                ->caption(Core::_('Ofdferma.setting_vat'));

            //Принудительная свертка позиций заказа
            $setting_collapse = Admin_Form_Entity::factory('Checkbox')
                ->name('OFDFERMA_COLLAPSE')
                ->value(defined('OFDFERMA_COLLAPSE') ? OFDFERMA_COLLAPSE : '')
                ->caption(Core::_('Ofdferma.setting_collapse'));

            // Название для такой позиции
            $setting_collapse_name = Admin_Form_Entity::factory('Input')
                ->caption(Core::_('Ofdferma.setting_collapse_name'))
                ->name('OFDFERMA_COLLAPSE_NAME')
                ->value(defined('OFDFERMA_COLLAPSE_NAME') ? OFDFERMA_COLLAPSE_NAME : '');

            //Статус, для которого формировать чек автоматически
            $setting_status = Admin_Form_Entity::factory('Select')
                ->options($oModelOfdferma->_api->getDataStatus())
                ->name('OFDFERMA_STATUS')
                ->value(defined('OFDFERMA_STATUS') ? OFDFERMA_STATUS : '')
                ->caption(Core::_('Ofdferma.setting_status'));

            //Электронный адрес для уведомлений об ошибках
            $setting_email = Admin_Form_Entity::factory('Input')
                ->caption(Core::_('Ofdferma.setting_email'))
                ->name('OFDFERMA_EMAIL')
                ->value(defined('OFDFERMA_EMAIL') ? OFDFERMA_EMAIL : '');


            // Добавляем во вкладку
            $oTabIncore
                ->add(Admin_Form_Entity::factory('Div')->class('row')
                    ->add($setting_user)
                    ->add($setting_pass)
                    ->add($setting_inn)
                    ->add($setting_nalog)
                    ->add($setting_vat)
                    ->add($setting_collapse)
                    ->add($setting_collapse_name)
                    ->add($setting_status)
                    ->add($setting_email)
                );


            // Добавляем табы
            $this
                ->addTab($oTabIncore);


            return $this;
	}

	/**
	 * Processing of the form. Apply object fields.
	 * @hostcms-event Site_Controller_AccountInfo.onAfterRedeclaredApplyObjectProperty
	 */
	protected function _applyObjectProperty()
	{
            $aConstantsData = array(
                'OFDFERMA_USER',
                'OFDFERMA_PASS',
                'OFDFERMA_INN',
                'OFDFERMA_NALOG',
                'OFDFERMA_VAT',
                'OFDFERMA_COLLAPSE',
                'OFDFERMA_COLLAPSE_NAME',
                'OFDFERMA_STATUS',
                'OFDFERMA_EMAIL'
            );
            
            foreach($aConstantsData as $constant_name){
                
                $oConstantTmp = Core_Entity::factory('Constant')->getByName($constant_name);
                if (is_null($oConstantTmp))
                {
                    $oConstantTmp = Core_Entity::factory('Constant');
                    $oConstantTmp->name = $constant_name;
                    $oConstantTmp->active = 1;
                }

                $oConstantTmp->value = trim(Core_Array::getPost($constant_name));
                $oConstantTmp->save();
            }

            Core_Event::notify(get_class($this) . '.onAfterRedeclaredApplyObjectProperty', $this, array($this->_Admin_Form_Controller));
	}

}