<?php

defined('HOSTCMS') || exit('HostCMS: access denied.');

require_once(__DIR__ . '/lib/ofdfermaApi.php');

/**
 *
 * Project: ofdferma
 * User: unrlab
 *
 */
class Ofdferma_Model extends Core_Entity {

    /**
     * Model name
     * @var mixed
     */
    protected $_modelName = 'ofdferma';

    /**
     * Name of the table
     * @var string
     */
    protected $_tableName = 'ofdferma';

    /**
     * Belongs to relations
     * @var array
     */
    protected $_belongsTo = array(
        'site' => array(),
    );

    /**
     * Disable markDeleted()
     * @var mixed
     */
    protected $_marksDeleted = NULL;

    
    public $_api = null;
    
    /**
     * Constructor.
     * @param int $id entity ID
     */
    public function __construct($id = NULL) {
        $this -> _api = new OfdfermaApi();
        
        parent::__construct($id);
      
        if (is_null($id)) {
            $this->_preloadValues['site_id'] = defined('CURRENT_SITE') ? CURRENT_SITE : 0;
        }
    }

    public function numBackend()
    {
        
        $res = $this->num;
        
        if ( ! in_array($this->status, array('CONFIRMED'))){
            $res .= '<br /><a title="Обновить" 
                href="/admin/ofdferma/index.php?hostcms[action]=updateStatus&amp;hostcms[checked][0][' .$this->id. ']=1" 
                onclick="$(\'#id_content #row_0_' .$this->id. '\').toggleHighlight(); $.adminCheckObject({objectId: \'check_0_' .$this->id. '\', windowId: \'id_content\'}); $.adminLoad({path: \'/admin/ofdferma/index.php\',action: \'updateStatus\'}); return false">
                Обновить статус
            </a>';
        }else{
            $link = $this -> _api -> getCheckLink($this);
            $res = "<a href='{$link}' target='_blank'>{$this->num}</a>";
        }
        
        return $res;
    }
    
    public function typeBackend()
    {
        return $this -> _api-> getDataType($this->type);
    }

    /**
     * Change item status
     * @return self
     */
    public function updateStatus() {
        
        $res = $this -> _api -> check_update($this->num);
        
        if ($res){
            Core_Message::show($res['mess'], $res['status'] ? 'message' : 'error');
        }else{
            Core_Message::show("Статус чека {$this->num} обновлен");
        }
    }  
    
    //Сохраняем заказ
    public static function onBeforeSaveOrder($object) {
        global $tmp_order_save;
        
        if ( is_null($tmp_order_save)){
            $status_ids = FALSE;
            
            //Проверяем если статус изменился
            if ($object->shop_order_status_id){
                $status_ids[] = $object->shop_order_status_id;
            }
            if ($object->canceled){
                $status_ids[] = 'canceled';
            }
            if ($object->paid){
                $status_ids[] = 'paid';
            }                

            if ($status_ids){
                $_api = new OfdfermaApi();
                $res = $_api -> set_status_order($object->id, $status_ids);

                if ($res){
                    Core_Message::show($res['mess'], $res['status'] ? 'message' : 'error');
                }
            }
            
            $tmp_order_save = TRUE;
        }
    }
    
    //Сохраняем товар
    public static function onBeforeSaveProduct($object) {
        global $tmp_product_save;
        
        if ( is_null($tmp_product_save)){
            $ofdferma_vat = isset($_POST['ofdferma_vat']) ? $_POST['ofdferma_vat'] : '';

            if ( ! Core_DataBase::instance()->query('SELECT * FROM ofdferma_link_product WHERE item_id = "' .(int)$object->id. '" LIMIT 1')->asObject(null)->result(FALSE)){
                Core_DataBase::instance()->query('INSERT INTO ofdferma_link_product (`item_id`, `vat`) VALUES("' .(int)$object->id. '", "' .addslashes($ofdferma_vat). '")');
            }else{
                Core_DataBase::instance()->query('UPDATE ofdferma_link_product SET `vat` = "' .addslashes($ofdferma_vat). '" WHERE `item_id` = "' .(int)$object->id. '" LIMIT 1');
            }

            $tmp_product_save = TRUE;
        }
    }
    
    /*
     * Форма заказа
     */

    public static function onAfterRedeclaredPrepareForm($controller, $args) {
        list($object, $Admin_Form_Controller) = $args;
		
        // Данное событие будет вызываться для всех форм, определяем с каким контроллером работаем
        switch (get_class($controller)) {
            //Страница товара
            case 'Shop_Item_Controller_Edit':
				if ('Shop_Item_Model' == get_class($object)){
					//Добавим новую вкладку
					$oTab = Admin_Form_Entity::factory('Tab')
							->caption(Core::_('Ofdferma.model_name'))
							->name('module_ofdferma');

					//Получаем модель
					$oModelOfdferma = Core_Entity::factory('Ofdferma');
					
					$aVat = Core_DataBase::instance()->query('SELECT * FROM ofdferma_link_product WHERE item_id = "' .(int)$object->id. '" LIMIT 1')->asObject(null)->result(FALSE);
					$sVat = isset($aVat[0]->vat) ? $aVat[0]->vat : '';
				   
					// НДС по умолчанию
					$oProductVat = Admin_Form_Entity::factory('Select')
						->options(array_merge(array('' => 'Из модуля'), $oModelOfdferma->_api->getDataVat()))
						->name('ofdferma_vat')
						->value($sVat)
						->caption(Core::_('Ofdferma.setting_vat'));

					//Добавим элементы во вкладку
					$oTab
						->add(Admin_Form_Entity::factory('Div')->class('row')
							->add($oProductVat)
					);

					$controller->addTab($oTab);
				}
            break;
            
            //Страница заказа
            case 'Shop_Order_Controller_Edit':
                
                //Добавим новую вкладку
                $oTab = Admin_Form_Entity::factory('Tab')
                        ->caption(Core::_('Ofdferma.model_name'))
                        ->name('module_ofdferma');


                // Сформировать чек прихода
                $oLinkIncome = Admin_Form_Entity::factory('Link');
                $oLinkIncome
                        ->a
                        ->class('btn btn-palegreen')
                        ->onclick($Admin_Form_Controller->getAdminLoadAjax(
                                        "/admin/ofdferma/order/check.php", NULL, NULL, "act=Income&shop_order_id=" . intval($object->id)
                        ))
                        ->value(Core::_('Ofdferma.order_btn_income'));

                // Сформировать чек возврата
                $oLinkIncomeReturn = Admin_Form_Entity::factory('Link');
                $oLinkIncomeReturn
                        ->a
                        ->class('btn btn-danger')
                        ->onclick($Admin_Form_Controller->getAdminLoadAjax(
                                        "/admin/ofdferma/order/check.php", NULL, NULL, "act=IncomeReturn&shop_order_id=" . intval($object->id)
                        ))
                        ->value(Core::_('Ofdferma.order_btn_income_return'));


                //Добавим элементы во вкладку
                $oTab
                        ->add(Admin_Form_Entity::factory('Div')->class('row')
                                ->add($oLinkIncome)
                                ->add($oLinkIncomeReturn)
                );

                $controller->addTab($oTab);
            break;
        }
    }

}
