<?php

defined('HOSTCMS') || exit('HostCMS: access denied.');

/**
 *
 * Project: ofdferma
 * User: unrlab
 *
 */
class Ofdferma_Module extends Core_Module {

    protected $_modulePath = 'ofdferma';
    protected $_userID = NULL;
    protected $_observers = '$ofdferma = CMS_FOLDER . "modules/ofdferma/observer.php"; if (file_exists($ofdferma)) { require_once($ofdferma);}';
    protected $_langs = array();

    /**
     * Module version
     * @var string
     */
    public $version = '1.0';

    /**
     * Module date
     * @var date
     */
    public $date = '2019-03-30';

    /**
     * Module name
     * @var string
     */
    protected $_moduleName = 'ofdferma';

    protected $_scheduleActions = array(
        0 => 'ofdfermaCheckUpdate',
    );
    
    /**
     * Constructor.
     */
    public function __construct() {
        parent::__construct();


        // Add CSS to template
        //Core_Page::instance()->css('/modules/ofdferma/css/sms.min.css');
        // Add template observer
        //Core_Event::attach('template.onAfterExecute', array('Alert_Observer', 'onAfterExecute'));




        $this->menu = array(
            array(
                'sorting' => 5001,
                'block' => 3,
                'ico' => 'fa fa-sheqel',
                'name' => Core::_('Ofdferma.host_menu'),
                'href' => "/admin/ofdferma/index.php",
                'onclick' => "$.adminLoad({path: '/admin/ofdferma/index.php'}); return false"
            )
        );

        //var_dump($this->menu);
    }

    /**
     * @return $this
     */
    protected function _getLangs() {
        $aAdmin_Languages = Core_Entity::factory('Admin_Language')->findAll();
        $this->_langs = $aAdmin_Languages;
        return $this;
    }

    /**
     * @param $lng
     * @return bool
     */
    protected function _checkLng($lng) {
        $aPath = explode('_', $this->_modulePath);
        $path = Core::$modulesPath;
        $path .= implode(DIRECTORY_SEPARATOR, $aPath) . DIRECTORY_SEPARATOR;
        $path .= 'i18n' . DIRECTORY_SEPARATOR . $lng . '.php';
        $path = Core_File::pathCorrection($path);

        if (is_file($path)) {
            return true;
        }
        return false;
    }

    /**
     * @param array $param
     * @return mixed
     */
    public function addForm(array $param) {
        
        $oAdmin_Form = Core_Entity::factory('Admin_Form')->getByGuid($param['guid']);
        if (is_null($oAdmin_Form)) {
            $oAdmin_Form = Core_Entity::factory('Admin_Form');

            $oAdmin_Form->guid = isset($param['guid']) ? $param['guid'] : '';
            $oAdmin_Form->on_page = isset($param['on_page']) ? $param['on_page'] : 20;
            $oAdmin_Form->key_field = isset($param['key_field']) ? $param['key_field'] : '';
            $oAdmin_Form->show_operations = isset($param['show_operations']) ? $param['show_operations'] : 0;
            $oAdmin_Form->show_group_operations = isset($param['show_group_operations']) ? $param['show_group_operations'] : 0;
            $oAdmin_Form->default_order_field = isset($param['default_order_field']) ? $param['default_order_field'] : 'id';
            $oAdmin_Form->default_order_direction = isset($param['default_order_direction']) ? $param['default_order_direction'] : 0;
            //$oAdmin_Form->user_id					= $this->_userID;
            $oAdmin_Form->save();

            if (!empty($this->_langs)) {
                $oAdmin_Word = Core_Entity::factory('Admin_Word');
                foreach ($this->_langs as $oAdmin_Language) {

                    if ($this->_checkLng($oAdmin_Language->shortname)) {
                        if (isset($param['wordname'])) {
                            $name = Core_I18n::instance()->get("{$param['wordname']}", $oAdmin_Language->shortname);
                        }
                        if (isset($param['worddescription'])) {
                            $description = Core_I18n::instance()->get("{$param['worddescription']}", $oAdmin_Language->shortname);
                        }

                        $oAdmin_Word_Value = Core_Entity::factory('Admin_Word_Value');
                        $oAdmin_Word_Value->admin_language_id = $oAdmin_Language->id;

                        $oAdmin_Word_Value->name = $name;
                        $oAdmin_Word_Value->description = $description;
                        $oAdmin_Word_Value->save();
                        $oAdmin_Word->add($oAdmin_Word_Value);
                    }
                }
                $oAdmin_Form->add($oAdmin_Word);
            }

            $oAdmin_Form->save();
        }


        return $oAdmin_Form;
    }

    /**
     * @param array $param
     * @return mixed
     */
    public function addField(array $param) {

        $oQueryBuilder = Core_QueryBuilder::select('*')
            ->clear()
            ->from('admin_form_fields')
            ->where('admin_form_id', '=', $param['admin_form_id'])
            ->where('name', '=', $param['name'])
            ->where('type', '=', $param['type'])
            ->limit(1);

        $sSql = $oQueryBuilder->build();
        
        $aObjects = $oQueryBuilder
                ->execute($sSql)
                ->asObject('Admin_Form_Field')
                ->result(false);
        
        $oAdmin_Form_Field = isset($aObjects[0]) ? $aObjects[0] : NULL;
        if (is_null($oAdmin_Form_Field)){
            $oAdmin_Form_Field = Core_Entity::factory('Admin_Form_Field');

            $oAdmin_Form_Field->name = isset($param['name']) ? $param['name'] : '';
            $oAdmin_Form_Field->type = isset($param['type']) ? $param['type'] : 1;
            $oAdmin_Form_Field->sorting = isset($param['sorting']) ? $param['sorting'] : 0;
            $oAdmin_Form_Field->allow_sorting = isset($param['allow_sorting']) ? $param['allow_sorting'] : 0;
            $oAdmin_Form_Field->allow_filter = isset($param['allow_filter']) ? $param['allow_filter'] : 0;
            $oAdmin_Form_Field->editable = isset($param['editable']) ? $param['editable'] : 0;
            $oAdmin_Form_Field->filter_type = isset($param['filter_type']) ? $param['filter_type'] : 0;
            //$oAdmin_Form_Field->user_id			    = $this->_userID;
            $oAdmin_Form_Field->format = isset($param['format']) ? $param['format'] : ''; //
            $oAdmin_Form_Field->ico = isset($param['ico']) ? $param['ico'] : '';
            $oAdmin_Form_Field->width = isset($param['width']) ? $param['width'] : '';
            $oAdmin_Form_Field->class = isset($param['class']) ? $param['class'] : '';
            $oAdmin_Form_Field->ico = isset($param['ico']) ? $param['ico'] : ''; //
            $oAdmin_Form_Field->image = isset($param['image']) ? $param['image'] : '';
            $oAdmin_Form_Field->link = isset($param['link']) ? $param['link'] : '';
            $oAdmin_Form_Field->onclick = isset($param['onclick']) ? $param['onclick'] : '';
            $oAdmin_Form_Field->list = isset($param['list']) ? $param['list'] : '';

            $oAdmin_Form_Field->admin_form_id = $param['admin_form_id'];
            $oAdmin_Form_Field->save();
            if (!empty($this->_langs)) {
                $oAdmin_Word = Core_Entity::factory('Admin_Word');
                foreach ($this->_langs as $oAdmin_Language) {
                    $name = $description = '';
                    if ($this->_checkLng($oAdmin_Language->shortname)) {
                        if (isset($param['wordname'])) {
                            $name = Core_I18n::instance()->get("{$param['wordname']}", $oAdmin_Language->shortname);
                        }
                        if (isset($param['worddescription'])) {
                            $description = Core_I18n::instance()->get("{$param['worddescription']}", $oAdmin_Language->shortname);
                        }

                        $oAdmin_Word_Value = Core_Entity::factory('Admin_Word_Value');
                        $oAdmin_Word_Value->admin_language_id = $oAdmin_Language->id;

                        $oAdmin_Word_Value->name = $name;
                        $oAdmin_Word_Value->description = $description;
                        $oAdmin_Word_Value->save();
                        $oAdmin_Word->add($oAdmin_Word_Value);
                    }
                }
                $oAdmin_Form_Field->add($oAdmin_Word);
            }
        }
        
        return $oAdmin_Form_Field;
    }
    
    /**
     * @param array $param
     */
    public function addAction(array $param) {

        $oQueryBuilder = Core_QueryBuilder::select('*')
            ->clear()
            ->from('admin_form_actions')
            ->where('admin_form_id', '=', $param['admin_form_id'])
            ->where('name', '=', $param['name'])
            ->limit(1);

        $sSql = $oQueryBuilder->build();
        
        $aObjects = $oQueryBuilder
                ->execute($sSql)
                ->asObject('Admin_Form_Field')
                ->result(false);
        
        $oAdmin_Form_Action = isset($aObjects[0]) ? $aObjects[0] : NULL;
        
        if (is_null($oAdmin_Form_Action)){
            $oAdmin_Form_Action = Core_Entity::factory('Admin_Form_Action');

            $oAdmin_Form_Action->admin_form_id = $param['admin_form_id'];
            $oAdmin_Form_Action->name = isset($param['name']) ? $param['name'] : '';
            $oAdmin_Form_Action->picture = isset($param['picture']) ? $param['picture'] : 1;
            $oAdmin_Form_Action->icon = isset($param['icon']) ? $param['icon'] : '';
            $oAdmin_Form_Action->color = isset($param['color']) ? $param['color'] : '';
            $oAdmin_Form_Action->single = isset($param['single']) ? $param['single'] : 1;
            $oAdmin_Form_Action->group = isset($param['group']) ? $param['group'] : 0;
            $oAdmin_Form_Action->sorting = isset($param['sorting']) ? $param['sorting'] : 0;
            $oAdmin_Form_Action->dataset = isset($param['dataset']) ? $param['dataset'] : -1;
            $oAdmin_Form_Action->confirm = isset($param['confirm']) ? $param['confirm'] : 0;
            //$oAdmin_Form_Action->user_id		= $this->_userID;
            $oAdmin_Form_Action->save();

            if (!empty($this->_langs)) {
                $oAdmin_Word = Core_Entity::factory('Admin_Word');
                foreach ($this->_langs as $oAdmin_Language) {
                    $name = $description = '';

                    if ($this->_checkLng($oAdmin_Language->shortname)) {
                        if (isset($param['wordname'])) {
                            $name = Core_I18n::instance()->get("{$param['wordname']}", $oAdmin_Language->shortname);
                        }
                        if (isset($param['worddescription'])) {
                            $description = Core_I18n::instance()->get("{$param['worddescription']}", $oAdmin_Language->shortname);
                        }


                        $oAdmin_Word_Value = Core_Entity::factory('Admin_Word_Value');
                        $oAdmin_Word_Value->admin_language_id = $oAdmin_Language->id;

                        $oAdmin_Word_Value->name = $name;
                        $oAdmin_Word_Value->description = $description;
                        $oAdmin_Word_Value->save();
                        $oAdmin_Word->add($oAdmin_Word_Value);
                    }
                }
                $oAdmin_Form_Action->add($oAdmin_Word);
            }
        }
    }

    //Запуск через планировщик
    public function callSchedule($action, $entityId)
    {
        switch ($action)
        {
            // ofdfermaCheckUpdate
            case 0:
                $oModelOfdferma = Core_Entity::factory('Ofdferma');
                $oModelOfdferma -> _api -> check_update();
            break;
        }
    }
    
    
    /**
     * Install.
     */
    public function install() {

        /*
         * Массив с языками
         */
        $this->_getLangs();
        //$this->_getUser();


        /*
         * Хуки
         */
        $text = Core_File::read(CMS_FOLDER . 'bootstrap.php');
        if (strpos($text, $this->_observers) == 0) {
            $fp = fopen(CMS_FOLDER . 'bootstrap.php', 'a');
            fwrite($fp, "\n\r" . $this->_observers);
            fclose($fp);
        }

        /*
         * Создание таблицы модуля
         */
        $query = "
            DROP TABLE IF EXISTS `ofdferma`;
            CREATE TABLE `ofdferma` (
              `id` int(11) NOT NULL AUTO_INCREMENT,
              `site_id` int(11) NOT NULL,
              `shop_id` int(11) NOT NULL,
              `num` varchar(36) NOT NULL,
              `type` varchar(12) NOT NULL,
              `inn` varchar(20) NOT NULL,
              `status` varchar(50) NOT NULL,
              `status_message` varchar(50) NOT NULL,
              `order_id` int(11) NOT NULL,
              `total` decimal(8,2) NOT NULL,
              `fn` varchar(50) NOT NULL,
              `rnm` varchar(50) NOT NULL,
              `fdn` varchar(50) NOT NULL,
              `fpd` varchar(50) NOT NULL,
              `created_at` datetime NOT NULL,
              `updated_at` datetime NOT NULL,
              PRIMARY KEY (`id`),
              UNIQUE KEY (`num`)
            ) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=0;
            
            DROP TABLE IF EXISTS `ofdferma_link_product`;
            CREATE TABLE `ofdferma_link_product` (
              `item_id` int(11) NOT NULL,
              `vat` varchar(20) NOT NULL,
              PRIMARY KEY (`item_id`)
            ) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=0;
        ";
        Sql_Controller::instance()->execute($query);


        /*
         * Форма для ofdferma
         */
        $param = array(
            'on_page'                   => 20,
            'key_field'                 => 'id',
            'show_operations'           => 0,
            'show_group_operations'     => 0,
            'default_order_field'       => 'created_at',
            'default_order_direction'   => 2,
            'guid'                      => 'ofdferma_list',
            'wordname'                  => 'ofdferma.model_name',
            'worddescription'           => '',
        );
        $oAdmin_Form = $this->addForm($param);


        /*
         * Поля для ofdferma
         */

        // Номер чека
        $param = array(
            'admin_form_id' => $oAdmin_Form->id,
            'name' => 'num',
            'sorting' => 1,
            'ico' => '',
            'type' => 1,
            'format' => '',
            'allow_sorting' => 0,
            'allow_filter' => 0,
            'editable' => 0,
            'filter_type' => 0,
            'class' => '',
            'width' => '',
            'image' => '',
            'link' => '',
            'onclick' => '',
            'list' => '',
            'wordname' => 'ofdferma.install_field_id',
            'worddescription' => '',
        );
        $this->addField($param);

        // Тип
        $param = array(
            'admin_form_id' => $oAdmin_Form->id,
            'name' => 'type',
            'sorting' => 2,
            'ico' => '',
            'type' => 8,
            'format' => '',
            'allow_sorting' => 0,
            'allow_filter' => 1,
            'editable' => 0,
            'filter_type' => 0,
            'class' => '',
            'width' => '',
            'image' => '',
            'link' => '',
            'onclick' => '',
            'list' => '',
            'wordname' => 'ofdferma.install_field_type',
            'worddescription' => '',
        );
        $this->addField($param);

        // Статус
        $param = array(
            'admin_form_id' => $oAdmin_Form->id,
            'name' => 'status_message',
            'sorting' => 3,
            'ico' => '',
            'type' => 1,
            'format' => '',
            'allow_sorting' => 0,
            'allow_filter' => 0,
            'editable' => 0,
            'filter_type' => 0,
            'class' => '',
            'width' => '',
            'image' => '',
            'link' => '',
            'onclick' => '',
            'list' => '',
            'wordname' => 'ofdferma.install_field_status_message',
            'worddescription' => '',
        );
        $this->addField($param);
        
        // Заказ
        $param = array(
            'admin_form_id' => $oAdmin_Form->id,
            'name' => 'order_id',
            'sorting' => 4,
            'ico' => '',
            'type' => 4,
            'format' => '',
            'allow_sorting' => 0,
            'allow_filter' => 1,
            'editable' => 0,
            'filter_type' => 0,
            'class' => '',
            'width' => '',
            'image' => '',
            'link' => '',
            'onclick' => '',
            'list' => '',
            'wordname' => 'ofdferma.install_field_order_id',
            'worddescription' => '',
        );
        $this->addField($param);
        
        // Сумма
        $param = array(
            'admin_form_id' => $oAdmin_Form->id,
            'name' => 'total',
            'sorting' => 5,
            'ico' => '',
            'type' => 1,
            'format' => '',
            'allow_sorting' => 0,
            'allow_filter' => 0,
            'editable' => 0,
            'filter_type' => 0,
            'class' => '',
            'width' => '',
            'image' => '',
            'link' => '',
            'onclick' => '',
            'list' => '',
            'wordname' => 'ofdferma.install_field_total',
            'worddescription' => '',
        );
        $this->addField($param);
        
        // ФН
        $param = array(
            'admin_form_id' => $oAdmin_Form->id,
            'name' => 'fn',
            'sorting' => 6,
            'ico' => '',
            'type' => 1,
            'format' => '',
            'allow_sorting' => 0,
            'allow_filter' => 0,
            'editable' => 0,
            'filter_type' => 0,
            'class' => '',
            'width' => '',
            'image' => '',
            'link' => '',
            'onclick' => '',
            'list' => '',
            'wordname' => 'ofdferma.install_field_fn',
            'worddescription' => '',
        );
        $this->addField($param);
        
        // РНМ
        $param = array(
            'admin_form_id' => $oAdmin_Form->id,
            'name' => 'rnm',
            'sorting' => 7,
            'ico' => '',
            'type' => 1,
            'format' => '',
            'allow_sorting' => 0,
            'allow_filter' => 0,
            'editable' => 0,
            'filter_type' => 0,
            'class' => '',
            'width' => '',
            'image' => '',
            'link' => '',
            'onclick' => '',
            'list' => '',
            'wordname' => 'ofdferma.install_field_rnm',
            'worddescription' => '',
        );
        $this->addField($param);
        
        // ФДН
        $param = array(
            'admin_form_id' => $oAdmin_Form->id,
            'name' => 'fdn',
            'sorting' => 8,
            'ico' => '',
            'type' => 1,
            'format' => '',
            'allow_sorting' => 0,
            'allow_filter' => 0,
            'editable' => 0,
            'filter_type' => 0,
            'class' => '',
            'width' => '',
            'image' => '',
            'link' => '',
            'onclick' => '',
            'list' => '',
            'wordname' => 'ofdferma.install_field_fdn',
            'worddescription' => '',
        );
        $this->addField($param);
        
        // ФПД
        $param = array(
            'admin_form_id' => $oAdmin_Form->id,
            'name' => 'fpd',
            'sorting' => 9,
            'ico' => '',
            'type' => 1,
            'format' => '',
            'allow_sorting' => 0,
            'allow_filter' => 0,
            'editable' => 0,
            'filter_type' => 0,
            'class' => '',
            'width' => '',
            'image' => '',
            'link' => '',
            'onclick' => '',
            'list' => '',
            'wordname' => 'ofdferma.install_field_fpd',
            'worddescription' => '',
        );
        $this->addField($param);
        
        // Магазин
        /*$param = array(
            'admin_form_id' => $oAdmin_Form->id,
            'name' => 'shop_id',
            'sorting' => 10,
            'ico' => '',
            'type' => 1,
            'format' => '',
            'allow_sorting' => 0,
            'allow_filter' => 1,
            'editable' => 0,
            'filter_type' => 0,
            'class' => '',
            'width' => '',
            'image' => '',
            'link' => '',
            'onclick' => '',
            'list' => '',
            'wordname' => 'ofdferma.install_field_shop_id',
            'worddescription' => '',
        );
        $this->addField($param);*/

        // Дата осздания
        $param = array(
            'admin_form_id' => $oAdmin_Form->id,
            'name' => 'created_at',
            'sorting' => 11,
            'ico' => '',
            'type' => 6,
            'format' => '',
            'allow_sorting' => 0,
            'allow_filter' => 1,
            'editable' => 0,
            'filter_type' => 0,
            'class' => '',
            'width' => '',
            'image' => '',
            'link' => '',
            'onclick' => '',
            'list' => '',
            'wordname' => 'ofdferma.install_field_created_at',
            'worddescription' => '',
        );
        $this->addField($param);
        
        
        //Ссылка обновить
        $param = array(
            'admin_form_id' => $oAdmin_Form->id,
            'name' => 'updateStatus',
            'picture' => '',
            'icon' => '',
            'color' => '',
            'single' => 0,
            'group' => 0,
            'sorting' => 10,
            'dataset' => -1,
            'confirm' => 0,
            'wordname' => 'ofdferma.install_action_changeStatus',
            'worddescription' => '',
        );
        $this->addAction($param);
        
        // Кнопка настройки
        $param = array(
            'admin_form_id' => $oAdmin_Form->id,
            'name' => 'settings',
            'picture' => '',
            'icon' => '',
            'color' => '',
            'single' => 0,
            'group' => 0,
            'sorting' => 50,
            'dataset' => -1,
            'confirm' => 0,
            'wordname' => 'ofdferma.install_action_settings',
            'worddescription' => '',
        );
        $this->addAction($param);
    }

    /**
     * Uninstall.
     */
    public function uninstall() {
        
        Core_Event::notify(get_class($this) . '.onBeforeUninstall', $this);
        
        // Удаление таблицы модуля
        $query  = '';
        $query .= "DROP TABLE IF EXISTS `ofdferma`;";
        $query .= "DROP TABLE IF EXISTS `ofdferma_link_product`;";
        
        // Выполняем запрос
        Sql_Controller::instance()->execute($query);

        // ofdferma
        $oAdmin_Form = Core_Entity::factory('Admin_Form')->getByGuid('ofdferma_list');
        if (!is_null($oAdmin_Form)) {
            // Удаление формы
            $oAdmin_Form->delete();
        }
    }

}
